# -*- coding: utf-8 -*-
"""
#
#     This file is part of the Test Set for BVP solvers
#     http://www.dm.uniba.it/~bvpsolvers/
#
#       python file to plot the computed solution
#       change the directory to the directory tests before to run it
#
#     DISCLAIMER: see
#     http://www.dm.uniba.it/~bvpsolvers/testsetbvpsolvers/?page_id=34
#
#     The most recent version of this source file can be found at
#     http://www.dm.uniba.it/~bvpsolvers/bvpTestSet/tests/BVPfplot.py
#
"""


def BVPfplot(PROBLEM, SOLVER, indsol, flout, PATH):
   import numpy as np
   import os #directive that includes path's utilities
   import matplotlib.pyplot as plt
   mypath = os.getcwd()
   #CONTROL OF INPUT ARGUMENTS MISSING
   if(PATH != ''): 
     os.chdir(PATH)
     mypath = os.getcwd() + "/"
     print("Path changed in:", mypath)   
   else: 
     #it's the same directory
     if (mypath[len(mypath)-5:len(mypath)] == 'tests'): #if directory is"../tests" don't changes path directory
         mypath=""
   file_ = mypath + PROBLEM + "_"+str.upper(SOLVER) + ".txt"
   dati = np.loadtxt(file_) #implicit conversion to float64 numbers      
   nind = len(indsol)
   for i in range(0,nind):
         plt.figure()
         title =  "PROBLEM= "+ PROBLEM + " SOLVER= " + SOLVER + " COMPONENT= "+ str(i+1)
         plt.title(title)
         plt.plot(dati[:,0],dati[:,i+1], '-o')
         if (flout):
           epsfile = mypath + PROBLEM + SOLVER + str(i+1) + ".eps"
           plt.savefig(epsfile, dpi=75) #SALVA FIGURE
         plt.show()
         
   
